package com.agilecontrol.nea.core.schema;

import com.agilecontrol.nea.core.schema.TableMapping;
import com.agilecontrol.nea.core.schema.TableMappingManager;
import com.agilecontrol.nea.util.ListSort;
import com.agilecontrol.nea.util.StringHashtable;
import com.agilecontrol.nea.util.StringUtils;
import java.io.FileOutputStream;
import java.util.Iterator;
import java.util.Vector;

public class VBXMLGenerator {

   private String dir = "F:/work5/vb/pos/dist/conf/ora.all";
   private String srcDir = "file:///E:/aic/tables.mit4";
   private boolean lowerCase = true;


   public VBXMLGenerator() throws Exception {
      this.gen();
   }

   private void gen() throws Exception {
      TableMappingManager manager = new TableMappingManager(this.srcDir);
      StringHashtable tableMaps = manager.getMappings();
      Vector c = new Vector(tableMaps.values());
      ListSort.sort(c);
      Iterator it = c.iterator();

      while(it.hasNext()) {
         TableMapping map = (TableMapping)it.next();
         this.createTableXML(map);
      }

   }

   private void createTableXML(TableMapping map) throws Exception {
      System.out.println("---" + map.name + "----");
      String s = this.additionalHandle(map.toXML());
      FileOutputStream file = new FileOutputStream(this.dir + "/" + (this.lowerCase?map.name.toLowerCase():map.name) + ".table");
      file.write(s.getBytes());
      file.close();
   }

   private String additionalHandle(String s) {
      s = StringUtils.replace(s, "com.agilecontrol.nea.core.security.PasswordInterpreter", "Schema.PasswordInterpreter");
      s = StringUtils.replace(s, "com.agilecontrol.nea.core.security.Permissions", "Schema.NopInterpreter");
      return s;
   }

   public static void main(String[] args) throws Exception {
      new VBXMLGenerator();
   }
}
